org.apache.felix.framework.cache

## Interface Content

All Known Implementing Classes:
  ConnectContentContent, ContentDirectoryContent, DirectoryContent, JarContent, MultiReleaseContent

    public interface Content

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `close()` This method must be called when the content is no longer needed so that any resourses being used (e.g., open files) can be closed.
`long` `getContentTime(String urlPath)`
`Enumeration<String>` `getEntries()` Returns an enumeration of entry names as `String` objects.
`byte[]` `getEntryAsBytes(String name)` This method returns the named entry as an array of bytes.
`Content` `getEntryAsContent(String name)` This method returns the named entry as an `IContent` Typically, this method only makes sense for entries that correspond to some form of aggregated resource (e.g., an embedded JAR file or directory), but implementations are free to interpret this however makes sense.
`String` `getEntryAsNativeLibrary(String name)` This method returns the named entry as a file in the file system for use as a native library.
`InputStream` `getEntryAsStream(String name)` This method returns the named entry as an input stream.
`URL` `getEntryAsURL(String name)` This method allows retrieving an entry as a local URL.
`boolean` `hasEntry(String name)` This method determines if the specified named entry is contained in the associated content.
`boolean` `isDirectory(String name)` This method determines if the specified named entry is contained in the associated content and is a directory.

### Method Detail

#### close

    void close()

This method must be called when the content is no longer needed so that any resourses being used (e.g., open files) can be closed. Once this method is called, the content is no longer usable. If the content is already closed, then calls on this method should have no effect.

#### hasEntry

    boolean hasEntry(String name)

This method determines if the specified named entry is contained in the associated content. The entry name is a relative path with '/' separators.

Parameters:
  `name` - The name of the entry to find.
Returns:
  `true` if a corresponding entry was found, `false` otherwise.

#### isDirectory

    boolean isDirectory(String name)

This method determines if the specified named entry is contained in the associated content and is a directory. The entry name is a relative path with '/' separators.

Parameters:
  `name` - The name of the entry to find.
Returns:
  `true` if a corresponding entry was found and is a directory, `false` otherwise.

#### getEntries

    Enumeration<String> getEntries()

Returns an enumeration of entry names as `String` objects. An entry name is a path constructed with '/' as path element separators and is relative to the root of the content. Entry names for entries that represent directories should end with the '/' character.

#### getEntryAsBytes

    byte[] getEntryAsBytes(String name)

This method returns the named entry as an array of bytes.

Parameters:
  `name` - The name of the entry to retrieve as a byte array.
Returns:
  An array of bytes if the corresponding entry was found, `null` otherwise.

#### getEntryAsStream

    InputStream getEntryAsStream(String name)
                          throws IOException

This method returns the named entry as an input stream.

Parameters:
  `name` - The name of the entry to retrieve as an input stream.
Returns:
  An input stream if the corresponding entry was found, `null` otherwise.
Throws:
  ``java.io.IOException`` - if any error occurs.
  `IOException`

#### getEntryAsContent

    Content getEntryAsContent(String name)

This method returns the named entry as an `IContent` Typically, this method only makes sense for entries that correspond to some form of aggregated resource (e.g., an embedded JAR file or directory), but implementations are free to interpret this however makes sense. This method should return a new `IContent` instance for every invocation and the caller is responsible for opening and closing the returned content object.

Parameters:
  `name` - The name of the entry to retrieve as an `IContent`.
Returns:
  An `IContent` instance if a corresponding entry was found, `null` otherwise.

#### getEntryAsNativeLibrary

    String getEntryAsNativeLibrary(String name)

This method returns the named entry as a file in the file system for use as a native library. It may not be possible for all content implementations (e.g., memory only) to implement this method, in which case it is acceptable to return `null`. Since native libraries can only be associated with a single class loader, this method should return a unique file per request.

Parameters:
  `name` - The name of the entry to retrieve as a file.
Returns:
  A string corresponding to the absolute path of the file if a corresponding entry was found, `null` otherwise.

#### getEntryAsURL

    URL getEntryAsURL(String name)

This method allows retrieving an entry as a local URL.

Parameters:
  `name` - The name of the entry to retrieve as a URL
Returns:
  A URL using a local protocol such as file, jar or null if not possible.

#### getContentTime

    long getContentTime(String urlPath)